#include "common.h"

void init_descriptor_tables();


//structure for a gdt entry
struct gdt_entry_struct
{
	u16int limit_low; //lower 16 bits of limit
	u16int base_low; //lower 16 bits of base
	u8int base_middle; //next 8 bits of the base
	u8int access; //flags, what ring this entry should run in
	u8int granularity;
	u8int base_high; //last 8 bits of the base
} __attribute__ ((packed));
typedef struct gdt_entry_struct gdt_entry_t;

//gdt pointer struct
struct gdt_ptr_struct
{
	u16int limit; //upper 16 bit of sector limits
	u32int base;  //address of first gdt entry
} __attribute__((packed));
typedef struct gdt_ptr_struct gdt_ptr_t;

//interupt struct
struct idt_entry_struct
{
	u16int base_low; //lower 16 bits for interupt address to be called
	u16int sel;      //kernel segment selector
	u8int always0;   //as the name suggest this must be 0 or christmas won't happen
	u8int flags;     //more flags
	u16int base_high;//higher 16 bits of address
} __attribute__ ((packed));
typedef struct idt_entry_struct idt_entry_t;

//struct for idt pointer
struct idt_ptr_struct
{
	u16int limit;
	u32int base; //the address to the first element
} __attribute__((packed));
typedef struct idt_ptr_struct idt_ptr_t;

//let us access the address of the isr handlers
extern void isr0 ();
extern void isr1 ();
extern void isr2 ();
extern void isr3 ();
extern void isr4 ();
extern void isr5 ();
extern void isr6 ();
extern void isr7 ();
extern void isr8 ();
extern void isr9 ();
extern void isr10 ();
extern void isr11 ();
extern void isr12 ();
extern void isr13 ();
extern void isr14 ();
extern void isr15 ();
extern void isr16 ();
extern void isr17 ();
extern void isr18 ();
extern void isr19 ();
extern void isr20 ();
extern void isr21 ();
extern void isr22 ();
extern void isr23 ();
extern void isr24 ();
extern void isr25 ();
extern void isr26 ();
extern void isr27 ();
extern void isr28 ();
extern void isr29 ();
extern void isr30 ();
extern void isr31 ();

